
#include "send_receive.h"
#include <strings.h>

#define MAX 30

Menu menu, pronto;

server(int coda)
{
	int ultimo;  // usato per memorizzare il numero dic caratteri di un messaggio
	FILE *menuptr;
	char errmsg[256], piatto[MAX];

	menu.mesg_type = PER_CUOCO;

	/* il cuoco riceve il nome del file in cui trovera` il menu;
	 * per convenzione il file ha il nome del cameriere.
	 * L'indicazione e` ricevuta come messaggio nell'unica coda di
	 * messaggi creata
	 */
	if ((ultimo=mesg_rcv(coda, &menu))< 0) exit(0);

	/* sostituzione di \n con \0 (fine stringa anziche' fine linea */
	menu.mesg_data[ultimo]= '\0';
	printf("\n preparo i piatti richiesti da %s \n", menu.mesg_data);

	/* il cuoco controlla che il file esista 
	 * se non esiste invia un messaggio che avvisa il cameriere
	 * che ha passato info errate
	 * */
	if ((menuptr = fopen(menu.mesg_data, "r")) == NULL) {
		sprintf(errmsg, ": non trovo il menu!");
		strcat(menu.mesg_data, errmsg);
		menu.mesg_len = strlen(menu.mesg_data);
		mesg_send(coda, &menu);
	}
	/* nel caso normale ... */
	else {
		pronto.mesg_type = PER_CAMERIERE;
		/* il cuoco legge le ordinazioni una per volta, 
		 * prepara i piatti e avvisa il cameriere */
		fscanf(menuptr, "%s", &(piatto[0]));
		while (!feof(menuptr)) { 
	                printf("\n CUOCO, preparo : %s \n", piatto);
			sleep(2); /* in questo tempo supponiamo che prepari il piatto */
			sprintf(pronto.mesg_data, "%s fatto", piatto);
			pronto.mesg_len = strlen(pronto.mesg_data)+1;
			mesg_send(coda, &pronto);
			/* cuoco legge cosa preparare */
		        fscanf(menuptr, "%s", &(piatto[0]));
		}
		fclose(menuptr);
	}

	/* messaggio di farewell */
	pronto.mesg_len=0;
	pronto.mesg_data[0]= '\0';
	mesg_send(coda, &pronto);
}


main()
{
	int coda;

	if ((coda = msgget(getppid(), PERMS | IPC_CREAT)) < 0) {
		printf("\nSERVER: impossibile avere coda 1\n");
		exit(-1);
	}

	server(coda);
	exit(0);

}
